import 'package:flutter/material.dart';

class PlusTile<T> extends StatefulWidget {
  PlusTile({
    Key? key,
    required this.title,
    this.subtitle,
    this.onTap,
    this.onLongTap,
    this.padding,
    this.margin,
    this.leading,
    this.trailing,
    this.color,
    this.decoration,
  });
  double? width = double.infinity;
  double? height = 65;
  Widget title;
  Widget? subtitle;
  Function? onTap;
  Function? onLongTap;
  EdgeInsetsGeometry? padding = const EdgeInsets.all(4);
  EdgeInsetsGeometry? margin = const EdgeInsets.all(4);
  Widget? leading;
  Widget? trailing;
  Color? color;
  Decoration? decoration;

  @override
  _PlusTileState createState() => _PlusTileState();
}

class _PlusTileState<T> extends State<PlusTile> {
  @override
  Widget build(BuildContext context) {
    return InkWell(
      child: Container(
        margin: widget.margin,
        width: widget.width,
        height: widget.height,
        decoration: widget.decoration,
        child: Row(
          children: [
            widget.leading != null
                ? SizedBox(
                    height: double.infinity,
                    child: widget.leading,
                  )
                : const SizedBox(),
            SizedBox(
              height: double.infinity,
              child: Expanded(
                  child: Padding(
                padding: const EdgeInsets.all(4.0),
                child: Column(
                  mainAxisAlignment: MainAxisAlignment.center,
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    Expanded(child: widget.title),
                    Padding(
                      padding: const EdgeInsets.only(
                        top: 3,
                        bottom: 3,
                      ),
                      child: widget.subtitle,
                    ),
                  ],
                ),
              )),
            ),
            widget.trailing != null
                ? SizedBox(
                    height: double.infinity,
                    child: widget.trailing,
                  )
                : const SizedBox(),
          ],
        ),
      ),
      onTap: () => widget.onTap,
      onLongPress: () => widget.onLongTap,
    );
  }
}
